package Spec;

import java.util.*;
import br.ufpe.abaco.compiler.*;



public class MapTerm extends AtomicTerm {
    private HashMap map;
    private StandardOperators stan;

    public MapTerm(HashMap m,StandardOperators st) {
	map = m;
	stan = st;
    }

    public MapTerm(Term src,Term dest,StandardOperators st) {
	map = new HashMap();
	map.put(src,dest);
	stan = st;
    }

    
    public HashMap contents() {
	return map;
    }

    public String toString() {
	StringBuffer b = new StringBuffer();
	
	if (map.size()==0)
	    return "empty-map";
	
	if (map.size() > 1) {
	    b.append("disjoint union ( ... )");
	    return b.toString();
	}
	Iterator i = map.keySet().iterator();
	while (i.hasNext()) {
	    Term t = (Term)i.next();
	    
	    b.append("map of ");
	    b.append(t);
	    b.append(" to ");
	    b.append(map.get(t));
	    if (i.hasNext())
		b.append(" , ");
	}
	if (map.size() > 1)
	    b.append(" )");
	return b.toString();
    }
    
    public boolean equals(Object o) {
	if (o instanceof MapTerm)
	    return ((MapTerm)o).map.equals(map);
	return false;
    }
    
    public int hashCode() {return map.hashCode();}

    public Term at(Term src) {
	return (Term)map.get(src);
    }

    public MapTerm overlay(MapTerm m) {
	HashMap nMap = new HashMap();
	nMap.putAll(map);
	nMap.putAll(m.map);
	return new MapTerm(nMap,stan);
    }
    public MapTerm disjoint_union(MapTerm m) {
	HashMap nMap = new HashMap();
	nMap.putAll(map);
	nMap.putAll(m.map);
	return new MapTerm(nMap,stan);
    }
    public SetTerm mapped_set() {
	HashSet nSet = new HashSet();
	nSet.addAll(map.keySet());
	return new SetTerm(nSet,stan);
    }

    
}
